module SIGALI_PROPERTY_COMB=
  pragmas 
      Comment " Sigali predefined library: property combination."
  end pragmas

   type setOfStates = boolean;
   process B_And =
        ( ? setOfStates PROP1, PROP2;
          ! setOfStates PROP;
        )
%      spec (| PROP1 ^+ PROP2 ^= PROP |)%
        pragmas 
        Sigali "&o1: &n(&i1, &i2);"
        Comment "Perform the And between two set of states: "
                 " e.g. B_And(B_True(A),B_False(B)) will compute the "
                 " set of states where A is true whereas B is false"
      end pragmas

   %B_And%; 
   process B_Or =
        ( ? setOfStates PROP1, PROP2;
          ! setOfStates PROP;
        )
%    spec (| PROP1 ^= PROP2 ^= PROP |)%
      pragmas 
        Sigali "&o1: &n(&i1, &i2);"
         Comment "Perform the or between two set of states: "
                 " e.g. B_Or(B_True(A),B_False(B) will compute the "
                 " set of states where A is true whereas B is false"
      end pragmas

   %B_Or%; 
   process Complement =
        ( ? setOfStates PROP1;
          ! setOfStates PROP;
        )
%       spec (| PROP1 ^= PROP |)%
      pragmas 
        Sigali "&o1: complement(&i1);"
        Comment "Compute the set of states where the property PROP1 is invalidated"
      end pragmas

   %Complement%; 
   process WhereEqual =
        ( ? setOfStates A, B;
          ! setOfStates PROP;
        )
%       spec (| A ^= B ^= PROP |)    %
      pragmas 
         Sigali "&o1: Equal(&i1, &i2);"
         Comment "compute the set of states where  the boolean A is equal to the boolean B"
      end pragmas

   %Equal%; 
      
   process TestEqual =
        ( ? setOfStates A, B;
          ! setOfStates PROP;
        )
%       spec (| A ^= B ^= PROP |)    %
      pragmas 
         Sigali "&o1: equal(&i1, &i2);"
         Comment " test whether A and B are equal."
      end pragmas;
      
   process Synch =
        ( ? setOfStates A, B;
          ! setOfStates PROP;
        )
%       spec (| A ^= B ^= PROP |)%
      pragmas 
         Sigali "&o1: &n(&i1, &i2);"
         Comment "compute the set of states where  the booleans A and B are present at the same time"
                 " respect to  the system syst. "
      end pragmas

   %Synch%; 

end;
